Home

Hedera

v1.0.0
Base URL
https://hedera.nownodes.io

Authentication

api-keyAuthapiKey

API Key: api-key in header

General

accounts

List account entities on network

GET
https://hedera.nownodes.io/api/v1/accounts

Returns a list of all account entity items on the network.

Parameters

account.balancestringquery

The optional balance value to compare against

account.idEntityIdQueryquery

The ID of the account to return information for

account.publickeystringquery

The account's public key to compare against

balancebooleantruequery

Whether to include balance information or not. If included, token balances are limited to at most 50 per account as outlined in HIP-367. If multiple values are provided the last value will be the only value used.

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get account by alias, id, or evm address

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}

Return the account transactions and balance information given an account alias, an account id, or an evm address. The information will be limited to at most 1000 token balances for the account as outlined in HIP-367. When the timestamp parameter is supplied, we will return transactions and account state for the relevant timestamp query. Balance information will be accurate to within 15 minutes of the provided timestamp query. Historical ethereum nonce information is currently not available and may not be the exact value at a provided timestamp.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

transactiontypeTransactionTypesATOMICBATCHCONSENSUSCREATETOPICCONSENSUSDELETETOPICCONSENSUSSUBMITMESSAGECONSENSUSUPDATETOPICCONTRACTCALLCONTRACTCREATEINSTANCECONTRACTDELETEINSTANCECONTRACTUPDATEINSTANCECRYPTOADDLIVEHASHCRYPTOAPPROVEALLOWANCECRYPTOCREATEACCOUNTCRYPTODELETECRYPTODELETEALLOWANCECRYPTODELETELIVEHASHCRYPTOTRANSFERCRYPTOUPDATEACCOUNTETHEREUMTRANSACTIONFILEAPPENDFILECREATEFILEDELETEFILEUPDATEFREEZENODENODECREATENODEDELETENODESTAKEUPDATENODEUPDATESCHEDULECREATESCHEDULEDELETESCHEDULESIGNSYSTEMDELETESYSTEMUNDELETETOKENAIRDROPTOKENASSOCIATETOKENBURNTOKENCANCELAIRDROPTOKENCLAIMAIRDROPTOKENCREATIONTOKENDELETIONTOKENDISSOCIATETOKENFEESCHEDULEUPDATETOKENFREEZETOKENGRANTKYCTOKENMINTTOKENPAUSETOKENREJECTTOKENREVOKEKYCTOKENUNFREEZETOKENUNPAUSETOKENUPDATETOKENUPDATENFTSTOKENWIPEUNCHECKEDSUBMITUNKNOWNUTILPRNGquery
transactionsbooleantruequery

If provided and set to false transactions will not be included in the response

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

List hooks for an account

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/hooks

Returns a list of hooks associated with a given account ID, alias, or EVM address.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

hook.idinteger<int64>[1, 9223372036854776000]query

The ID of the hook

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get nfts for an account info

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/nfts

Returns information for all non-fungible tokens for an account.

Ordering

When considering NFTs, their order is governed by a combination of their numerical token.Id and serialnumber values, with token.id being the parent column. A serialnumbers value governs its order within the given token.id

In that regard, if a user acquired a set of NFTs in the order (2-2, 2-4 1-5, 1-1, 1-3, 3-3, 3-4), the following layouts illustrate the ordering expectations for ownership listing

  1. All NFTs in ASC order: 1-1, 1-3, 1-5, 2-2, 2-4, 3-3, 3-4
  2. All NFTs in DESC order: 3-4, 3-3, 2-4, 2-2, 1-5, 1-3, 1-1
  3. NFTs above 1-1 in ASC order: 1-3, 1-5, 2-2, 2-4, 3-3, 3-4
  4. NFTs below 3-3 in ASC order: 1-1, 1-3, 1-5, 2-2, 2-4
  5. NFTs between 1-3 and 3-3 inclusive in DESC order: 3-4, 3-3, 2-4, 2-2, 1-5, 1-3

Note: The default order for this API is currently DESC

Filtering

When filtering there are some restrictions enforced to ensure correctness and scalability.

The table below defines the restrictions and support for the NFT ownership endpoint

Query ParamComparison OperatorSupportDescriptionExample
token.ideqYSingle occurrence only.?token.id=X
neN
lt(e)YSingle occurrence only.?token.id=lte:X
gt(e)YSingle occurrence only.?token.id=gte:X
serialnumbereqYSingle occurrence only. Requires the presence of a token.id query?serialnumber=Y
neN
lt(e)YSingle occurrence only. Requires the presence of an lte or eq token.id query?token.id=lte:X&serialnumber=lt:Y
gt(e)YSingle occurrence only. Requires the presence of an gte or eq token.id query?token.id=gte:X&serialnumber=gt:Y
spender.ideqY?spender.id=Z
neN
lt(e)Y?spender.id=lt:Z
gt(e)Y?spender.id=gt:Z

Note: When searching across a range for individual NFTs a serialnumber with an additional token.id query filter must be provided. Both filters must be a single occurrence of gt(e) or lt(e) which provide a lower and or upper boundary for search.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

serialnumberstringquery

The nft serial number (64 bit type). Requires a tokenId value also be populated.

spender.idEntityIdQueryquery

The ID of the spender to return information for

token.idEntityIdQueryquery

The ID of the token to return information for

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get past staking reward payouts for an account

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/rewards

Returns information for all past staking reward payouts for an account.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get token relationships info for an account

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/tokens

Returns information for all token relationships for an account.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

token.idEntityIdQueryquery

The ID of the token to return information for

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get crypto allowances for an account info

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/allowances/crypto

Returns information for all crypto allowances for an account.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

spender.idEntityIdQueryquery

The ID of the spender to return information for

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get fungible token allowances for an account

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/allowances/tokens

Returns information for fungible token allowances for an account.

Ordering

The order is governed by a combination of the spender id and the token id values, with spender id being the parent column. The token id value governs its order within the given spender id.

Note: The default order for this API is currently ASC

Filtering

When filtering there are some restrictions enforced to ensure correctness and scalability.

The table below defines the restrictions and support for the endpoint

Query ParamComparison OperatorSupportDescriptionExample
spender.ideqYSingle occurrence only.?spender.id=X
neN
lt(e)YSingle occurrence only.?spender.id=lte:X
gt(e)YSingle occurrence only.?spender.id=gte:X
token.ideqYSingle occurrence only. Requires the presence of a spender.id query?token.id=lt:Y
neN
lt(e)YSingle occurrence only. Requires the presence of an lte or eq spender.id query?spender.id=lte:X&token.id=lt:Y
gt(e)YSingle occurrence only. Requires the presence of an gte or eq spender.id query?spender.id=gte:X&token.id=gt:Y

Both filters must be a single occurrence of gt(e) or lt(e) which provide a lower and or upper boundary for search.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

spender.idEntityIdQueryquery

The ID of the spender to return information for

token.idEntityIdQueryquery

The ID of the token to return information for

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get non fungible token allowances for an account

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/allowances/nfts

Returns an account's non-fungible token allowances.

Ordering

The order is governed by a combination of the account ID and the token ID values, with account ID being the parent column. The token ID value governs its order within the given account ID.

Note: The default order for this API is currently ascending. The account ID can be the owner or the spender ID depending upon the owner flag.

Filtering

When filtering there are some restrictions enforced to ensure correctness and scalability.

The table below defines the restrictions and support for the endpoint

Query ParamComparison OperatorSupportDescriptionExample
account.ideqYSingle occurrence only.?account.id=X
neN
lt(e)YSingle occurrence only.?account.id=lte:X
gt(e)YSingle occurrence only.?account.id=gte:X
token.ideqYSingle occurrence only. Requires the presence of an account.id parameter?account.id=X&token.id=eq:Y
neN
lt(e)YSingle occurrence only. Requires the presence of an lte or eq account.id parameter?account.id=lte:X&token.id=lt:Y
gt(e)YSingle occurrence only. Requires the presence of an gte or eq account.id parameter?account.id=gte:X&token.id=gt:Y

Both filters must be a single occurrence of gt(e) or lt(e) which provide a lower and or upper boundary for search.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

account.idEntityIdQueryquery

The ID of the account to return information for

token.idEntityIdQueryquery

The ID of the token to return information for

ownerbooleantruequery

When the owner value is true or omitted, the accountId path parameter will specify the ID of the owner, and the API will retrieve the allowances that the owner has granted to different spenders. Conversely, when the owner value is false, the accountId path parameter will indicate the ID of the spender who has an allowance, and the API will instead provide the allowances granted to the spender by different owners of those tokens.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

airdrops

Get outstanding token airdrops sent by an account

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/airdrops/outstanding

Returns outstanding token airdrops that have been sent by an account.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

receiver.idEntityIdQueryquery

The ID of the receiver to return information for

serialnumberstringquery

The nft serial number (64 bit type). Requires a tokenId value also be populated.

token.idEntityIdQueryquery

The ID of the token to return information for

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get pending token airdrops received by an account

GET
https://hedera.nownodes.io/api/v1/accounts/{idOrAliasOrEvmAddress}/airdrops/pending

Returns pending token airdrops that have been received by an account.

Parameters

idOrAliasOrEvmAddressstringrequiredpath

Account alias or account id or evm address

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

sender.idEntityIdQueryquery

The ID of the sender to return information for

serialnumberstringquery

The nft serial number (64 bit type). Requires a tokenId value also be populated.

token.idEntityIdQueryquery

The ID of the token to return information for

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

balances

List account balances

GET
https://hedera.nownodes.io/api/v1/balances

Returns a list of account and token balances on the network. The latest balance information is returned when there is no timestamp query parameter, otherwise, the information is retrieved from snapshots with 15-minute granularity. This information is limited to at most 50 token balances per account as outlined in HIP-367. As such, it's not recommended for general use and we instead recommend using either /api/v1/accounts/{id}/tokens or /api/v1/tokens/{id}/balances to obtain the current token balance information and /api/v1/accounts/{id} to return the current account balance.

Parameters

account.idstringquery

Account id or account alias with no shard realm or evm address with no shard realm

account.balancestringquery

The optional balance value to compare against

account.publickeystringquery

The account's public key to compare against

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

blocks

List blocks

GET
https://hedera.nownodes.io/api/v1/blocks

Returns a list of blocks on the network.

Parameters

block.numberstringquery

The block's number

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get block by hash or number

GET
https://hedera.nownodes.io/api/v1/blocks/{hashOrNumber}

Returns the block information by given hash or number.

Parameters

hashOrNumberstringrequiredpath

Accepts both eth and hedera hash format or block number

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

contracts

Invoke a smart contract

POST
https://hedera.nownodes.io/api/v1/contracts/call

Returns a result from EVM execution such as cost-free execution of read-only smart contract queries, gas estimation, and transient simulation of read-write operations. If the estimate field is set to true gas estimation is executed. However, gas estimation only supports the latest block. When estimate is false, it can process calls against the earliest block and specific historical blocks when a hexadecimal or decimal block number is provided in the block field for eth_call operations. Link to Supported/Unsupported Operations Table The operations types which are not currently supported should return 501 error status.

Body

application/json
blockstring | null

Hexadecimal block number or the string "latest", "pending", "earliest". Defaults to "latest".

datastring<binary> | null

Hexadecimal method signature and encoded parameters. Up to 131072 bytes as at most 262146 hexadecimal digits including optional leading 0x.

estimateboolean | null

Whether gas estimation is called. Defaults to false.

fromstring<binary> | null

The 20-byte hexadecimal EVM address the transaction is sent from.

gasinteger<int64> | null>= 0

Gas provided for the transaction execution. Defaults to 15000000.

gasPriceinteger<int64> | null>= 0

Gas price used for each paid gas.

tostring<binary>required

The 20-byte hexadecimal EVM address the transaction is directed to.

valueinteger<int64> | null>= 0

Value sent with this transaction. Defaults to 0.

Response

200OK

OK

400Bad Request

Validation error

404Not Found

Not found error

415Unsupported Media Type

Unsupported media type error

429Too Many Requests

Too many requests

500Internal Server Error

Generic error

501Not Implemented

Not implemented error

Authorization

api-keyAuthapiKey in header

List contract entities on network

GET
https://hedera.nownodes.io/api/v1/contracts

Returns a list of all contract entity items on the network.

Parameters

contract.idstringquery

The ID of the smart contract

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get contract by id

GET
https://hedera.nownodes.io/api/v1/contracts/{contractIdOrAddress}

Return the contract information given an id

Parameters

contractIdOrAddressstringrequiredpath

The ID or hex encoded EVM address (with or without 0x prefix) associated with this contract.

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

List contract results from a contract on the network

GET
https://hedera.nownodes.io/api/v1/contracts/{contractIdOrAddress}/results

Returns a list of all ContractResults for a contract's function executions.

Parameters

contractIdOrAddressstringrequiredpath

The ID or hex encoded EVM address (with or without 0x prefix) associated with this contract.

block.hashstringquery

The block's hash. If multiple values are provided the last value will be the only value used.

block.numberstringquery

The block's number

fromstringquery

Account ID or EVM address executing the contract

internalbooleanfalsequery

Whether to include child transactions or not

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

transaction.indexinteger<int32>>= 0query

The transaction index in the block

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

The contract state from a contract on the network

GET
https://hedera.nownodes.io/api/v1/contracts/{contractIdOrAddress}/state

Returns a list of all contract's slots. If no timestamp is provided, returns the current state.

Parameters

contractIdOrAddressstringrequiredpath

The ID or hex encoded EVM address (with or without 0x prefix) associated with this contract.

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

slotstringquery

The slot's number

timestampArray<string>query

The consensus timestamp of the contract state as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get the contract result from a contract on the network executed at a given timestamp

GET
https://hedera.nownodes.io/api/v1/contracts/{contractIdOrAddress}/results/{timestamp}

Returns a single ContractResult for a contract's function executions at a specific timestamp.

Parameters

contractIdOrAddressstringrequiredpath

The ID or hex encoded EVM address (with or without 0x prefix) associated with this contract.

timestampstringrequiredpath

The Unix timestamp in seconds.nanoseconds format, the timestamp at which the associated transaction reached consensus. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

206Partial Content

Partial Content

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

List contract results from all contracts on the network

GET
https://hedera.nownodes.io/api/v1/contracts/results

Returns a list of all ContractResults for all contract's function executions.

Parameters

fromstringquery

Account ID or EVM address executing the contract

block.hashstringquery

The block's hash. If multiple values are provided the last value will be the only value used.

block.numberstringquery

The block's number

internalbooleanfalsequery

Whether to include child transactions or not

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

transaction.indexinteger<int32>>= 0query

The transaction index in the block

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get the contract result from a contract on the network for a given transactionId or ethereum transaction hash

GET
https://hedera.nownodes.io/api/v1/contracts/results/{transactionIdOrHash}

Returns a single ContractResult for a contract's function executions for a given transactionId or ethereum transaction hash.

Parameters

transactionIdOrHashstringrequiredpath

Transaction Id or a 32 byte hash with optional 0x prefix

nonceinteger<int32>>= 00query

Filter the query result by the nonce of the transaction. A zero nonce represents user submitted transactions while a non-zero nonce is generated by main nodes. The filter honors the last value. Default is 0 when not specified.

Response

200OK

OK

206Partial Content

Partial Content

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get the contract actions from a contract on the network for a given transactionId or ethereum transaction hash

GET
https://hedera.nownodes.io/api/v1/contracts/results/{transactionIdOrHash}/actions

Returns a list of ContractActions for a contract's function executions for a given transactionId or ethereum transaction hash.

Parameters

transactionIdOrHashstringrequiredpath

Transaction Id or a 32 byte hash with optional 0x prefix

indexstringquery

The index of a contract action

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get the opcode traces for a historical transaction on the network with the given transaction ID or hash

GET
https://hedera.nownodes.io/api/v1/contracts/results/{transactionIdOrHash}/opcodes

Re-executes a transaction and returns a result containing detailed information for the execution, including all values from the {@code stack}, {@code memory} and {@code storage} and the entire trace of opcodes that were executed during the replay.

Note that to provide the output, the transaction needs to be re-executed on the EVM, which may take a significant amount of time to complete if stack and memory information is requested.

Parameters

transactionIdOrHashstringrequiredpath

Transaction Id or a 32 byte hash with optional 0x prefix

stackbooleantruequery

If provided and set to false, stack information will not be included in the response

memorybooleanfalsequery

If provided and set to true, memory information will be included in the response

storagebooleanfalsequery

If provided and set to true, storage information will be included in the response

Response

200OK

OK

400Bad Request

Validation error

404Not Found

Transaction or record file not found

429Too Many Requests

Too many requests

Authorization

api-keyAuthapiKey in header

List contract logs from a contract on the network

GET
https://hedera.nownodes.io/api/v1/contracts/{contractIdOrAddress}/results/logs

Search the logs of a specific contract across multiple contract calls. Chained logs are not included but can be found by calling /api/v1/contracts/{contractId}/results/{timestamp} or /api/v1/contracts/results/{transactionId}. When searching by topic a timestamp parameter must be supplied and span a time range of at most seven days.

Ordering

The order is governed by the combination of timestamp and index values. If the index param is omitted, the order is determined by the timestamp only.

Note: The default order for this API is currently DESC

Filtering

When filtering there are some restrictions enforced to ensure correctness and scalability.

The table below defines the restrictions and support for the endpoint

Query ParamComparison OperatorSupportDescriptionExample
indexeqYSingle occurrence only. Requires the presence of timestamp?index=X
neN
lt(e)YSingle occurrence only. Requires the presence of timestamp?index=lte:X
gt(e)YSingle occurrence only. Requires the presence of timestamp?index=gte:X
timestampeqYSingle occurrence only.?timestamp=Y
neN
lt(e)YSingle occurrence only. Optional second timestamp gt(e)?timestamp=lte:Y
gt(e)YSingle occurrence only. Optional second timestamp lt(e)?timestamp=gte:Y

Both filters must be a single occurrence of gt(e) or lt(e) which provide a lower and or upper boundary for search.

Parameters

contractIdOrAddressstringrequiredpath

The ID or hex encoded EVM address (with or without 0x prefix) associated with this contract.

indexstringquery

Contract log index

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

topic0Array<string>query

The first topic associated with a contract log. Requires a timestamp range also be populated.

topic1Array<string>query

The second topic associated with a contract log. Requires a timestamp range also be populated.

topic2Array<string>query

The third topic associated with a contract log. Requires a timestamp range also be populated.

topic3Array<string>query

The fourth topic associated with a contract log. Requires a timestamp range also be populated.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

List contracts logs across many contracts on the network

GET
https://hedera.nownodes.io/api/v1/contracts/results/logs

Search the logs across many contracts with multiple contract calls. Chained logs are not included but can be found by calling /api/v1/contracts/{contractId}/results/{timestamp} or /api/v1/contracts/results/{transactionId}. When searching by topic a timestamp parameter must be supplied and span a time range of at most seven days.

Ordering

The order is governed by the combination of timestamp and index values. If the index param is omitted, the order is determined by the timestamp only.

Note: The default order for this API is currently DESC

Filtering

When filtering there are some restrictions enforced to ensure correctness and scalability.

The table below defines the restrictions and support for the endpoint

Query ParamComparison OperatorSupportDescriptionExample
indexeqYSingle occurrence only. Requires the presence of timestamp?index=X
neN
lt(e)YSingle occurrence only. Requires the presence of timestamp?index=lte:X
gt(e)YSingle occurrence only. Requires the presence of timestamp?index=gte:X
timestampeqYSingle occurrence only.?timestamp=Y
neN
lt(e)YSingle occurrence only. Optional second timestamp gt(e)?timestamp=lte:Y
gt(e)YSingle occurrence only. Optional second timestamp lt(e)?timestamp=gte:Y

Both filters must be a single occurrence of gt(e) or lt(e) which provide a lower and or upper boundary for search.

Parameters

indexstringquery

Contract log index

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

topic0Array<string>query

The first topic associated with a contract log. Requires a timestamp range also be populated.

topic1Array<string>query

The second topic associated with a contract log. Requires a timestamp range also be populated.

topic2Array<string>query

The third topic associated with a contract log. Requires a timestamp range also be populated.

topic3Array<string>query

The fourth topic associated with a contract log. Requires a timestamp range also be populated.

transaction.hashstringquery

A hex encoded 32-byte ethereum transaction hash or 48-byte hedera transaction hash.

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

network

Get the network exchange rate to estimate costs

GET
https://hedera.nownodes.io/api/v1/network/exchangerate

Returns the network's exchange rate, current and next.

Parameters

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

500Internal Server Error

Service Unavailable

Authorization

api-keyAuthapiKey in header

Get the network fees

GET
https://hedera.nownodes.io/api/v1/network/fees

Returns the estimated gas in tinybars per each transaction type. Default order is ASC. Currently only ContractCall, ContractCreate and EthereumTransaction transaction types are supported.

Parameters

orderanyascdescascquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

500Internal Server Error

Service Unavailable

Authorization

api-keyAuthapiKey in header

Get the network address book nodes

GET
https://hedera.nownodes.io/api/v1/network/nodes

Returns the network's list of nodes used in consensus

Parameters

file.idEntityIdQueryquery

The ID of the file entity

limitinteger<int32>[1, 100]25query

The maximum number of items to return

node.idstringquery

The ID of the node

orderanyascdescascquery

The order in which items are listed

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get network stake information

GET
https://hedera.nownodes.io/api/v1/network/stake

Returns the network's current stake information.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

No network stake data found

500Internal Server Error

Service Unavailable

Authorization

api-keyAuthapiKey in header

Get the network supply

GET
https://hedera.nownodes.io/api/v1/network/supply

Returns the network's released supply of hbars

Parameters

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

schedules

List schedules entities

GET
https://hedera.nownodes.io/api/v1/schedules

Lists schedules on the network that govern the execution logic of scheduled transactions. This includes executed and non executed schedules.

Parameters

account.idEntityIdQueryquery

The ID of the account to return information for

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

schedule.idEntityIdQueryquery

The ID of the schedule to return information for

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get schedule by id

GET
https://hedera.nownodes.io/api/v1/schedules/{scheduleId}

Returns schedule information based on the given schedule id

Parameters

scheduleIdEntityId | nullrequiredpath

Schedule id

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

transactions

List transactions

GET
https://hedera.nownodes.io/api/v1/transactions

Lists transactions on the network. This includes successful and unsuccessful transactions.

Parameters

account.idEntityIdQueryquery

The ID of the account to return information for

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

transactiontypeTransactionTypesATOMICBATCHCONSENSUSCREATETOPICCONSENSUSDELETETOPICCONSENSUSSUBMITMESSAGECONSENSUSUPDATETOPICCONTRACTCALLCONTRACTCREATEINSTANCECONTRACTDELETEINSTANCECONTRACTUPDATEINSTANCECRYPTOADDLIVEHASHCRYPTOAPPROVEALLOWANCECRYPTOCREATEACCOUNTCRYPTODELETECRYPTODELETEALLOWANCECRYPTODELETELIVEHASHCRYPTOTRANSFERCRYPTOUPDATEACCOUNTETHEREUMTRANSACTIONFILEAPPENDFILECREATEFILEDELETEFILEUPDATEFREEZENODENODECREATENODEDELETENODESTAKEUPDATENODEUPDATESCHEDULECREATESCHEDULEDELETESCHEDULESIGNSYSTEMDELETESYSTEMUNDELETETOKENAIRDROPTOKENASSOCIATETOKENBURNTOKENCANCELAIRDROPTOKENCLAIMAIRDROPTOKENCREATIONTOKENDELETIONTOKENDISSOCIATETOKENFEESCHEDULEUPDATETOKENFREEZETOKENGRANTKYCTOKENMINTTOKENPAUSETOKENREJECTTOKENREVOKEKYCTOKENUNFREEZETOKENUNPAUSETOKENUPDATETOKENUPDATENFTSTOKENWIPEUNCHECKEDSUBMITUNKNOWNUTILPRNGquery
resultanysuccessfailquery

The transaction success type.

typeanycreditdebitquery

The transaction account balance modification type.

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get transaction by id

GET
https://hedera.nownodes.io/api/v1/transactions/{transactionId}

Returns transaction information based on the given transaction id

Parameters

transactionIdstringrequiredpath

Transaction id

nonceinteger<int32>>= 0query

Filter the query result by the nonce of the transaction. A zero nonce represents user submitted transactions while a non-zero nonce is generated by main nodes. The filter honors the last value. If not specified, all transactions with specified payer account ID and valid start timestamp match. If multiple values are provided the last value will be the only value used.

scheduledbooleanquery

Filter transactions by the scheduled flag. If true, return information for the scheduled transaction. If false, return information for the non-scheduled transaction. If not present, return information for all transactions matching transactionId. If multiple values are provided the last value will be the only value used.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

topics

Get topic by ID

GET
https://hedera.nownodes.io/api/v1/topics/{topicId}

Returns the topic details for the given topic ID.

Parameters

topicIdEntityId | nullrequiredpath

Topic id

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

List topic messages by id

GET
https://hedera.nownodes.io/api/v1/topics/{topicId}/messages

Returns the list of topic messages for the given topic id.

Parameters

topicIdEntityId | nullrequiredpath

Topic id

encodingstringquery
limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescascquery

The order in which items are listed

sequencenumberinteger<int64>>= 0query
timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Topic Not Found

Authorization

api-keyAuthapiKey in header

Get topic message by id and sequence number

GET
https://hedera.nownodes.io/api/v1/topics/{topicId}/messages/{sequenceNumber}

Returns a single topic message for the given topic id and sequence number.

Parameters

topicIdEntityId | nullrequiredpath

Topic id

sequenceNumberinteger<int64>>= 0requiredpath

Topic message sequence number

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get topic message by consensusTimestamp

GET
https://hedera.nownodes.io/api/v1/topics/messages/{timestamp}

Returns a topic message the given the consensusTimestamp.

Parameters

timestampstringrequiredpath

The Unix timestamp in seconds.nanoseconds format, the timestamp at which the associated transaction reached consensus. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

tokens

List tokens

GET
https://hedera.nownodes.io/api/v1/tokens

Returns a list of tokens on the network.

Parameters

account.idEntityIdQueryquery

The ID of the account to return information for

limitinteger<int32>[1, 100]25query

The maximum number of items to return

namestringquery

Partial or full token name. Not allowed to be used with token.id or account.id parameter. Pagination is not supported with the use of this parameter and results are ordered by token.id with respect to the order parameter.

orderanyascdescascquery

The order in which items are listed

publickeystringquery

The public key to compare against

token.idEntityIdQueryquery

The ID of the token to return information for

typeArray<string>query

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get token by id

GET
https://hedera.nownodes.io/api/v1/tokens/{tokenId}

Returns token entity information given the id

Parameters

tokenIdEntityId | nullrequiredpath

Token id

timestampstringquery

The Unix timestamp in seconds.nanoseconds format. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

List token balances

GET
https://hedera.nownodes.io/api/v1/tokens/{tokenId}/balances

Returns a list of token balances given the id. This represents the Token supply distribution across the network

Parameters

tokenIdEntityId | nullrequiredpath

Token id

account.balancestringquery

The optional balance value to compare against

account.idEntityIdQueryquery

The ID of the account to return information for

account.publickeystringquery

The account's public key to compare against

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

List nfts

GET
https://hedera.nownodes.io/api/v1/tokens/{tokenId}/nfts

Returns a list of non-fungible tokens

Parameters

tokenIdEntityId | nullrequiredpath

Token id

account.idEntityIdQueryquery

The ID of the account to return information for

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

serialnumberstringquery

The nft serial number (64 bit type). Requires a tokenId value also be populated.

Response

200OK

OK

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header

Get nft info

GET
https://hedera.nownodes.io/api/v1/tokens/{tokenId}/nfts/{serialNumber}

Returns information for a non-fungible token

Parameters

tokenIdEntityId | nullrequiredpath

Token id

serialNumberinteger<int64>[1, 9223372036854776000]1requiredpath

The nft serial number

Response

200OK

OK

400Bad Request

Invalid parameter

404Not Found

Not Found

Authorization

api-keyAuthapiKey in header

Get an nfts transction history

GET
https://hedera.nownodes.io/api/v1/tokens/{tokenId}/nfts/{serialNumber}/transactions

Returns a list of transactions for a given non-fungible token

Parameters

tokenIdEntityId | nullrequiredpath

Token id

serialNumberinteger<int64>[1, 9223372036854776000]1requiredpath

The nft serial number

limitinteger<int32>[1, 100]25query

The maximum number of items to return

orderanyascdescdescquery

The order in which items are listed

timestampArray<string>query

The consensus timestamp as a Unix timestamp in seconds.nanoseconds format with an optional comparison operator. See unixtimestamp.com for a simple way to convert a date to the 'seconds' part of the Unix time.

Response

200OK

OK

206Partial Content

Partial Content

400Bad Request

Invalid parameter

Authorization

api-keyAuthapiKey in header